#include <iostream>
#include <string>

using namespace std;

class IntefejsTv
{
public:
	virtual void wlacz() = 0;
	virtual void wylacz() = 0;
	virtual void wlaczKanal(int Kanal) = 0;
};

class SamsungTv : public IntefejsTv
{
public:
	void wlacz()
	{
		cout << "SamsungTv zostal wlaczony" << endl;
	}
	void wylacz()
	{
		cout << "SamsungTv zostal wylaczony" << endl;
	}
	void wlaczKanal(int Kanal)
	{
		cout << "Wlaczylismy kanal: " << Kanal << endl;
	}
};

class LGTv : public IntefejsTv
{
public:
	void wlacz()
	{
		cout << "LGTv zostal wlaczony" << endl;
	}
	void wylacz()
	{
		cout << "LGTv zostal wylaczony" << endl;
	}
	void wlaczKanal(int Kanal)
	{
		cout << "Wlaczylismy kanal: " << Kanal << endl;
	}
};

class AbstrakcyjntPilotTv
{
protected:
	IntefejsTv * tv;
public:
	virtual void przyciskWlacz() = 0;
	virtual void przyciskWylacZ() = 0;
};

class KonkretnyPilotTv : public AbstrakcyjntPilotTv
{

public:

	KonkretnyPilotTv(IntefejsTv * tv)
	{
		this->tv = tv;
	}

	void przyciskWlacz()
	{
		this->tv->wlacz();
	}
	void przyciskWylacZ()
	{
		this->tv->wylacz();
	}
};

int main()
{
	
	IntefejsTv * samsung = new SamsungTv();
	IntefejsTv * lg = new LGTv();
	
	AbstrakcyjntPilotTv * pilotDoSamsunga = new KonkretnyPilotTv(samsung);
	AbstrakcyjntPilotTv * pilotDoLG = new KonkretnyPilotTv(lg);
	
	pilotDoSamsunga->przyciskWlacz();
	pilotDoLG->przyciskWlacz();	

	pilotDoLG->przyciskWylacZ();
	
	return 0;
}
