#include <iostream>
#include <string>

using namespace std;

class InterfejsSamochodu
{
public:
	virtual void prowadz() = 0;
};

class Osoba
{
	string Imie;
	bool jestPrawko;
public:
	Osoba(string Imie, bool jestPrawko){
		this->Imie = Imie;
		this->jestPrawko = jestPrawko;
	};
	
	bool czyJestPrawko(){
		return this->jestPrawko;
	}
};

class Samochod : public InterfejsSamochodu
{

public:
	void prowadz() {
		cout << "Brum brum!" << endl;
	}
};

class PelnomocnikSamochodu : public InterfejsSamochodu
{
	InterfejsSamochodu * samochod;
	Osoba * osoba;
public:
	PelnomocnikSamochodu(Osoba * osoba){
		this->osoba = osoba;
		samochod = new Samochod();
	}

	void prowadz(){

		if(osoba->czyJestPrawko() == false){
			cout << " Przykro mi nie mozesz prowadzic samochodu!" << endl;
		}
		else
			samochod->prowadz();
	}
};

/*

int main(){

	Osoba * jan = new Osoba("Janek",false);
	PelnomocnikSamochodu * samochod = new PelnomocnikSamochodu(jan);
	samochod->prowadz();

	return 0;
}
*/