#include <iostream>

using namespace std;

class AbstrakcyjnaWtyczkaPL
{
public:
	virtual void bolceOkragle() = 0;
	virtual void iloscBolcow() = 0;
};

class WtyczkaPL : public AbstrakcyjnaWtyczkaPL
{
public:
	void bolceOkragle()
	{
		cout << "Mamy bolce okragle" << endl;
	}
	void iloscBolcow()
	{
		cout << "Mamy 2 bolce" << endl;
	}
};

class AbstrakcyjneGanizdkoUK
{
public:
	virtual void bolcePlaskie() = 0;
	virtual void iloscBolcow() = 0;
};

class GniazdkoUk : public AbstrakcyjneGanizdkoUK
{
public:
	void bolcePlaskie()
	{
		cout << "Mamy bolce plaskie!" << endl;
	}
	void iloscBolcow()
	{
		cout << "Mamy 3 bolce" << endl;
	}
};

class AdapterPldoUK : public AbstrakcyjnaWtyczkaPL
{
public:
	AbstrakcyjneGanizdkoUK * mojeAbstrakcyjneGanizdkoUk;
	AdapterPldoUK(AbstrakcyjneGanizdkoUK * gniazdkoUk )
	{
		this->mojeAbstrakcyjneGanizdkoUk = gniazdkoUk;
	}

	void bolceOkragle()
	{
		mojeAbstrakcyjneGanizdkoUk->bolcePlaskie();
	}
	void iloscBolcow()
	{
		mojeAbstrakcyjneGanizdkoUk->iloscBolcow();
	}
};

/*

int main()
{
	GniazdkoUk * mojeGniazdkoUk = new GniazdkoUk();
	AbstrakcyjnaWtyczkaPL * adapter = new AdapterPldoUK(mojeGniazdkoUk);

	adapter->bolceOkragle();
	adapter->iloscBolcow();
	
	return 0;
}
*/