#include <iostream>
#include <string>
#include <vector>
#include <iterator>


using namespace std;

class InterfejsPracownika
{
public:
	void virtual przedstaw() = 0;
};

// Li

class Pracownik : public InterfejsPracownika
{
	string Imie;
	string Nazwisko;
	int zarobek;
public:
	Pracownik(string Imie, string Nazwisko, int zarobek){
		this->Imie = Imie;
		this->Nazwisko = Nazwisko;
		this->zarobek = zarobek;	
	}

	void przedstaw()
	{
		cout << "Imie: " + this->Imie << " " << "Nazwisko: " << this->Nazwisko << " " << "Zarobek: " << this->zarobek << endl; 
	}
};

// Kompozyt

class KompozytPracownikow : public InterfejsPracownika
{

	vector < InterfejsPracownika * > pracownicy;

public:

	void dodaj(InterfejsPracownika * pracownik){

		pracownicy.push_back(pracownik);
	}

	void przedstaw()
	{

		for( vector<InterfejsPracownika *>::iterator it = pracownicy.begin() ; it != pracownicy.end(); ++it) {
			(*it)->przedstaw();
		}
	}
};


/*
int main()
{

	Pracownik * jan = new Pracownik("Jan","Kowalski",1999);
	Pracownik * franek = new Pracownik("Franek","Frankowski",2500);
	Pracownik * krzys = new Pracownik("Krzysztof","Nowak",5500);

	KompozytPracownikow * kompozyt = new KompozytPracownikow();

	kompozyt->dodaj(jan);
	kompozyt->dodaj(franek);
	kompozyt->dodaj(krzys);

	kompozyt->przedstaw();
	
	return 0;
}
*/